$INTERFACE U1FSE1                                             99/12/01
$REM LU
  $N='NF'
  $NN='NC'
  $HS=H
  $HERF='S'
  $HESR='S'
  $IF(MODEL='AF') $HESR='B'
  $IF(MODEL='AQ') $HESR='B'
  $IF(MODEL='AP') $HESR='B'
$REM  $ADD(REAL,'\$CFO($NC+1)\$CZO($NC)')
  $ADD(REAL,'\$CFO($NC+1)')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $IF(KBF>0) $CONSTR='C'
  $MODP='FF'
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(TYPE='L')
    $HELP
      LINEAR EQUATIONS FOR DIRECTION DETERMINATION
        K - KKT SYSTEM
        G - RANGE SPACE ELIMINATION
        Z - NULL SPACE ELIMINATION
    $CHECK(DECOMP,'K','K\G\Z',2,NO)
  $ELSEIF(TYPE='G')
    $DECOMP='Z'
    $HELP
      DIAGONAL PRECONDITIONING
        1 - INDEFINITE PRECONDITIONING - NORMAL EQUATION APPROACH
        2 - INDEFINITE PRECONDITIONING - AUGMENTED SYSTEM APPROACH
    $CHECK(MOS2,1,'1\2',3)
    $NOS2=MOS2
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $IF(DECOMP='K')
    $HELP
       METHOD
         1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
         3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
         4 - INEXACT SOLUTION BY THE CONJUGATE RESIDUAL METHOD
         5 - INEXACT SOLUTION BY THE SYMMETRIC QMR METHOD
         6 - INEXACT SOLUTION BY THE NONSYMMETRIC CGS METHOD
    $CHECK(NUMBER,3,'1\3\4\5\6',2,NO)
    $IF(NUMBER=1) $MOS2=0
    $HELP
      PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
             0 - PRECONDITIONING IS SUPPRESSED
       -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
                 EQUATION APPROACH.
             2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
                 SYSTEM APPROACH.
       -3 OR 3 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
                 PERTURBATION OF THE SCHUR COMPLEMENT
      MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
      MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
    $CHECK(MOS2,1,'-3\-1\0\1\2\3',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-3) $NOS2=3
  $ELSEIF(DECOMP='G')
    $HELP
      METHOD
        3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
            METHOD WITH GILL-MURRAY DECOMPOSITION
        4 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
            METHOD WITH BUNCH-PARLETT DECOMPOSITION
    $CHECK(NUMBER,3,'3\4',2,NO)
    $HELP
      PRECONDITIONING THE SCHUR COMPLEMENT
             0 - PRECONDITIONING IS SUPPRESSED
      -1 OR +1 - PRECONDITIONING BY THE CHOLESKI DECOMPOSITION
                 OF THE SCHUR COMPLEMENT
      -2 OR +2 - POLYNOMIAL PRECONDITIONING BY THE CHOLESKI
                 DECOMPOSITION OF THE NORMAL EQUATIONS
      MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
      MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
    $CHECK(MOS2,0,'-2\-1\0\1\2',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-2) $NOS2=2
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF3,'1.0$P 2',REAL,3)
  $ELSEIF(DECOMP='Z')
    $HELP
      METHOD
        3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
            METHOD PRECONDITIONED BY THE NORMAL EQUATION.
    $CHECK(NUMBER,3,'3',2,NO)
    $HELP
      PRECONDITIONING THE REDUCED SYSTEM
       -1 OR 1 - PRECONDITIONING BASED ON A DIAGONAL APPROXIMATION
                 OF THE HESSIAN MATRIX - NORMAL EQUATION APPROACH
       -2 OR 2 - PRECONDITIONING BASED ON A DIAGONAL APPROXIMATION
                 OF THE HESSIAN MATRIX - AUGMENTED SYSTEM APPROACH
      MOS2 > 0 - DIAGONAL MATRIX IN THE PRECONDITIONER
      MOS2 < 0 - UNIT MATRIX IN THE PRECONDITIONER
    $CHECK(MOS2,1,'-2\-1\1\2',3)
    $NOS2=MOS2
    $IF(NOS2=-1) $NOS2=1
    $IF(NOS2=-2) $NOS2=2
  $ENDIF
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.1$P 0',REAL,4)
  $KDS=0
  $IF(TYPE='L')
    $HELP
      CHOICE OF THE MERIT STRATEGY:
        P - PENALTY FUNCTION
        M - MARKOV FILTER
        F - FLETCHER-LEYFFER FILTER
    $CHECK(MERIT,'P','P\M\F',2,NO)
    $IF(MERIT='P')
      $HELP
        MERIT FUNCTION
          0 - MERIT FUNCTION IS NOT USED
          1 - POWELL L1 PENALTY FUNCTION
          2 - L2 AUGMENTED LAGRANGIAN FUNCTION
          3 - L1 AUGMENTED LAGRANGIAN FUNCTION
          4 - HAN L1 PENALTY FUNCTION
          5 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
      $CHECK(MEP,2,'0\1\2\3\4\5\6',2)
      $IF(MEP=6) $KDS=1
      $IF(MEP=0) $KTERS=6
      $HELP
        USE OF CORRECTION STEP
          1 - BASIC STEP
          2 - CORRECTION STEP
      $CHECK(MEP1,1,'1\2',4)
      $HELP
        INITIAL LAGRANGE MULTIPLIERS
          1 - FROM THE PREVIOUS ITERATION
          2 - FROM THE LEAST SQUARES SOLUTION
      $CHECK(MEP2,1,'1\2',4)
      $MEP3=1
      $IF(MEP<>2) $MEP3=1
      $HELP
        FORM OF THE PENALTY TERM
          1 - BASIC PENALTY TERM
          2 - BOGGS-TOLLE PENALTY TERM
      $CHECK(MEP3,1,'1\2',4)
      $STEP=1
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
          1-UNIT INITIAL STEPSIZE
          2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR VM METHODS
          3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
            STEPSIZE FOR CG METHODS
          4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
      $CHECK(INITS,1,'1\2\3\4',4)
    $ELSEIF(MERIT='F')
      $HELP
        MAXIMUM NUMBER OF FILTER SAMPLES
      $CHECK(MS,50,INT,3)
      $IF(MS<5) $MS=5
      $FS='FS'
      $ADD(REAL,'\$FS($MS,2)')
      $MEP=0
      $MEP1=0
      $MEP2=0
      $MEP3=0
      $STEP=7
      $INITS=1
      $ADD(INIT)
        INITS=$INITS
      $ENDADD
    $ELSEIF(MERIT='M')
      $FS='FS'
      $ADD(REAL,'\$FS(2)')
      $MEP=0
      $MEP1=0
      $MEP2=0
      $MEP3=0
      $STEP=8
      $INITS=1
      $ADD(INIT)
        INITS=$INITS
      $ENDADD
    $ENDIF
  $ELSEIF(TYPE='G')
    $MERIT='P'
    $HELP
      MERIT FUNCTION
        0 - MERIT FUNCTION IS NOT USED
        1 - POWELL L1 PENALTY FUNCTION
        2 - L2 AUGMENTED LAGRANGIAN FUNCTION
        3 - L1 AUGMENTED LAGRANGIAN FUNCTION
        4 - HAN L1 PENALTY FUNCTION
        5 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
    $CHECK(MEP,2,'0\1\2\3\4\5\6',2)
    $IF(MEP=6) $KDS=1
    $IF(MEP=0) $KTERS=6
    $MEP1=0
    $MEP2=0
    $MEP3=0
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2\3',4)
  $IF(HESR='B')
    $HELP
      TYPE OF SPARSE UPDATE:
        M - BASIC MARWILL UPDATE
        B - PARTITIONED VARIABLE METRIC UPDATES
    $CHECK(UPDATE,'B','M\B',3,NO)
    $IF(UPDATE='B')
      $IF($DEF(MET3))
        $IF(MET3=3) $MET3=1
      $ENDIF
      $HELP
        SUBJECTS OF UPDATES
          0 - CONSTRAINT FUNCTIONS
          1 - CONSTRAINT FUNCTIONS MULTIPLIED BY SIGNS
              OF THE LAGRANGIAN MULTIPLIERS
          2 - TERMS OF THE LAGRANGIAN FUNCTION
      $CHECK(MET5,1,'0\1\2',4)
      $SUBST('UFSET2')
      $SUBST('UCSET6')
      $ISNA=2
      $ADD(INIT)
        ISNA=2
      $ENDADD
    $ELSE
      $HESR='S'
    $ENDIF
  $ELSE
    $UPDATE='M'
  $ENDIF
  $IF(UPDATE='M')
    $IF(DECOMP='G')
      $HH='HH'
      $ADD(REAL,'\$HH($MMAX)')
    $ENDIF
  $ENDIF
  $MCL=NC
   MCL=NC
  $GN=GF
  $SN=S
  NDECF=0
  $SUBST('UCGS03')
  IF (IER.NE.0) THEN
  CALL UOERR1('U2FSE1',83)
  ITERM=-83
  GO TO $80
  ELSE IF (NC.GT.NCE) THEN
  CALL UOERR1('U2FSE1',84)
  ITERM=-84
  GO TO $80
  END IF
  $IDECC=0
  $IF(MEP1>1)
    $SUBST('UCESS1')
  $ELSEIF(MEP2>1)
    $SUBST('UCESS1')
  $ELSEIF(MEP3>1)
    $SUBST('UCESS1')
  $ELSEIF(DECOMP='K')
    $IF(NOS2=1) $SUBST('UCESS1')
  $ELSEIF(DECOMP='G')
    $IF(NOS2>0) $SUBST('UCESS1')
  $ELSEIF(DECOMP='Z')
    $IF(NOS2=1) $SUBST('UCESS1')
  $ENDIF
  IF (ITERM.NE.0) THEN
  IF (ITERM.EQ.-85) TDXX='DENSE R.'
  GO TO $80
  ENDIF
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $ADD(SINIT)
    $IF(MOS2=0)
      CALL UXVSET(NC,1.0$P-8,$CZ)
    $ELSE
      CALL UXVSET(NC,0.0$P 0,$CZ)
    $ENDIF
  $ENDADD
  $IF(KBF>0) $SUBST('UYFPC1')
  $IF(MODELF='YES')
$REM    $NUM=3
  $ELSE
$REM    $NUM=4
  $ENDIF
  $IF(DECOMP='G')
    $IF(NUMBER=3) $SUBST('UYSFSH')
    $IF(NUMBER=4) $SUBST('UYSFIH')
  $ELSEIF(NUMBER=1)
    $JOB=1
    $SUBST('UYSFIB')
  $ELSEIF(NOS2=2)
    $JOB=2
    $SUBST('UYSFIB')
  $ELSEIF(NOS2=3)
    $SUBST('UYSFSH')
  $ENDIF
  $IF(MEP1>1)
    $SUBST('UYSFSB')
  $ELSEIF(MEP2>1)
    $SUBST('UYSFSB')
  $ELSEIF(MEP3>1)
    $SUBST('UYSFSB')
  $ELSEIF(DECOMP='K')
    $IF(MOS2=1) $SUBST('UYSFSB')
  $ELSEIF(DECOMP='G')
    $IF(MOS2>0) $SUBST('UYSFSB')
  $ELSEIF(DECOMP='Z')
    $IF(NOS2=1) $SUBST('UYSFSB')
  $ENDIF
  $HF=H
*
*     ----------------------
*     VARIABLE METRIC METHOD
*     TEMPLATE : U1FSE1
*     ----------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  IF (ITERM.NE.0) GO TO $80
$L=$10 ; $LABEL
  $KD=1
  $LET='F'
  $SUBST('UP1$(MODP)3')
  $IF(MERIT='F')
    FC=CMAX
  $ELSEIF(MERIT='M')
    FC=CMAX
  $ELSE
    CF(NC+1)=F$LET
  $ENDIF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  $IF(MEP2>1)
    IF (LD.EQ.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    $SUBST('UCSLG1')
    ENDIF
  $ELSEIF(MEP3>1)
    IF (LD.GE.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    $SUBST('UCSLG1')
    ENDIF
  $ELSEIF(MEP1>1)
    IF (LD.GE.1) THEN
    $SUBST('UCENS2')
    IDECC=0
    $IDECC=1
    ENDIF
  $ELSEIF(DECOMP='G')
    $IF(NOS2=2)
      IF (LD.GE.1) THEN
      $SUBST('UCENS2')
      IDECC=0
      ENDIF
    $ENDIF
  $ENDIF
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $IF(MEP3=1) $SUBST('UP0AF1')
        $IF(MEP3=2) $SUBST('UP0AF2')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $SUBST('UP0AF1')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='F')
    KS=1
    FS(1,1)=-ETA9
    FS(1,2)= MAX(ONE,TEN*FC)
  $ELSEIF(MERIT='M')
    FS(1)=-ETA9
    FS(2)= MAX(ONE,TEN*FC)
  $ENDIF
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(KBF>0)
    $ADD(INTEGER,'\IRESTS')
    IRESTS=IREST
    $SUBST('UYRMC0')
    IREST=IRESTS
  $ENDIF
$L=$ 40 ; $LABEL
  $IF(UPDATE='B')
    $SUBST('UUBSD1')
    $SUBST('UUCSD1')
  $ELSEIF(DECOMP='G')
    $H=HH
    $SUBST('UUSSD1')
    $H=HS
  $ELSE
    $SUBST('UUSSD1')
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINB(NF,M,$IX,$JH)
    CALL UXVINB(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(HESR='B')
    $SUBST('UYT$(HESR)$(CONSTR)H')
    $SUBST('UFSET4')
    $SUBST('UFSET6')
  $ELSEIF(DECOMP='G')
    IDECF=0
    CALL UXVCOP(IH(NF+1)-1,$HH,$HS)
    $SUBST('UYT$(HESR)$(CONSTR)H')
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(KBF>0)
    IF (SQRT(UXVDOT(NC,$S(NF+1),$S(NF+1))).GT.1.0D 6*SNORM)&
    CALL UXVSET(NC,ZERO,$S(NF+1))
  $ENDIF
  $SUBST('UD1T$(TYPE)3')
  $IF(KBF>0)
    CALL UXVINE(M,$JH)
    CALL UXVINE(MC,$JCG)
    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
  $ENDIF
$REM  CALL UXVCOP(NC,$CZ,$CZO)
  $IF(TYPE='L')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $IF(MEP3=1) $SUBST('UP0AF1')
        $IF(MEP3=2) $SUBST('UP0AF2')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        R=ZERO
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='P')
      $IF(MEP=0)
        F=CF(NC+1)
      $ELSEIF(MEP=1)
        $SUBST('UP0SA1')
      $ELSEIF(MEP=2)
        $SUBST('UP0AF1')
      $ELSEIF(MEP=3)
        $SUBST('UP0AF3')
      $ELSEIF(MEP=4)
        $SUBST('UP0SA2')
      $ELSEIF(MEP=5)
        $SUBST('UP0AF4')
      $ELSEIF(MEP=6)
        $SUBST('UP0GF1')
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(KBF>0)
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(NC+1,$CF,$CFO)
  $IF(HESR='B')
    CALL UXVCOP(MA,$AG,$AGO)
    CALL UXVCOP(MC,$CG,$CGO)
  $ENDIF
  $IF(MEP1>1)
    $SUBST('UCSLG2')
    IF (ITERS.EQ.5) GOTO $64
  $ENDIF
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $IF(MEP1>1)
    IF (IPOM3.GT.0) THEN
    CALL UXUDIR(NF,R*R,$GS,$X,$X,$IX,KBF)
    ELSE IF (IPOM3.LT.0) THEN
    IF (R.EQ.ONE) LD=0
    ENDIF
  $ENDIF
  $SUBST('UCBS04')
  $IF(HESR='B')
    ISNA=1
  $ENDIF
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  $IF(HESR='B')
    ISNA=2
    $IF(KDA=1) LD=0
  $ENDIF
  ISNC=2
  $IF(KDC=1) LD=0
$REM  CALL UXVDIR(NC,R,$S(NF+1),$CZO,$CZ)
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
    $IF(HESR='B')
      CALL UXVCOP(MC,$CGO,$CG)
      CALL UXVCOP(MA,$AGO,$AG)
    $ENDIF
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
$REM  CALL UXVCOP(NC,$CZO,$CZ)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  CALL UXVDIR(NC,R,$S(NF+1),$CZ,$CZ)
  $IF(HESR='B')
  $ELSE
    IF (NIT.NE.LIT+1) THEN
    CALL UXVSCL(NC,R,S(NF+1),S(NF+1))
    CALL UXSCMD(NF,NC,MC,$CG,$ICG,$JCG,$S(NF+1),ONE,$GO,$GO)
    ENDIF
  $ENDIF
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(HESR='B')
    $HELP
      SELECTION OF SELF SCALING:
        1 - SELF SCALING SUPPRESSED
        2 - INITIAL SELF SCALING
        3 - CONTROLLED SELF SCALING
        4 - INTERVAL SELF SCALING
        5 - SELF SCALING IN EACH ITERATION
    $CHECK(MET1,3,'1\2\3\4\5',4)
    $IF(KBF>0) CALL UXVINB(NF,MA,$IX,$JAG)
    $SUBST('UYTC$(CONSTR)D')
    IDECF=0
    $IHLP=2
    $SUBST('UUB$(UPDATE)M$(IHLP)')
    $SUBST('UUC$(UPDATE)M$(IHLP)')
  $ELSE
    $IF(DECOMP='G')
      IDECF=0
      $H=HH
    $ENDIF
    $SUBST('UYTR$(CONSTR)D')
    IDECF=0
    $IF(KBF>0) CALL UXVINB(NF,M,$IX,$JH)
    $SUBST('UUS$(UPDATE)M1')
  $ENDIF
  IF (ITERH.NE.0) CALL UYRES1('UPDATE  ')
  $IF(KBF>0)
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GOTO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF(NC+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1FSE1'
  $ENDADD
  $EXIT
