$INTERFACE U1MDU1                                             97/12/01
$REM LU
  $N='N'
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\IMD')
  $IF(CLASS='LP')
    $SUBP='L'
    $TYPE='G'
  $ELSE
    $SUBP='Q'
    $HELP
      TYPE OF METHOD:
        L - LINE SEARCH
        G - GENERAL TRUST REGION
        C - GENERAL TRUST REGION WITH SECOND ORDER CORRECTION
    $CHECK(TYPE,'L','L\G\C',2,NO)
  $ENDIF
  $DECOMP=SUBP
  $UPDATE='B'
  $HELP
    RESTART AFTER UNSUCCESSFUL VARIABLE METRIC UPDATE:
      0 - NO RESTART
      1 - BASIC RESTART
  $CHECK(MOT2,0,'0\1',4)
  $IF(SUBP='Q')
    $HELP
      QUADRATIC PROGRAMMING METHOD:
        1 - DUAL QUADRATIC PROGRAMMING METHOD
        2 - PRIMAL QUADRATIC PROGRAMMING METHOD
    $CHECK(NUMBER,'1','1\2',2,NO)
  $ELSE
    $ISNF=0
    $NUMBER=2
  $ENDIF
  $IF(NUMBER=1)
    $ADD(REAL,'\$AFO($NA)')
  $ELSE
    $ADD(REAL,'\$AFO(2*$NA)')
  $ENDIF
  $AZS='AZ'
  $IF(TYPE='L')
    $KDS=0
    $IF(NUMBER=1)
      $HELP
        LINE SEARCH INTERPOLATION
          1 - BISECTION
          2 - TWO POINT QUADRATIC INTERPOLATION
          3 - THREE POINT QUADRATIC INTERPOLATION
          4 - THREE POINT CUBIC INTERPOLATION
          5 - SPECIAL INTERPOLATION
      $CHECK(MES,1,'1\2\3\4\5',3)
      $STEP=1
      $IF(MES=5) $STEP=5
      $HELP
        CHOICE OF THE INITIAL STEPSIZE:
         -1 - SPECIAL INITIAL STEPSIZE FOR THE MINIMAX APPROXIMATION
          1 - UNIT INITIAL STEPSIZE
      $CHECK(INITS,1,'-1\1',4)
    $ELSE
      $HELP
        LINE SEARCH INTERPOLATION
          1 - BISECTION
          2 - TWO POINT QUADRATIC INTERPOLATION
          3 - THREE POINT QUADRATIC INTERPOLATION
          4 - THREE POINT CUBIC INTERPOLATION
      $CHECK(MES,1,'1\2\3\4',3)
      $STEP=1
      $INITS=1
      $ADD(INIT)
        INITS=$INITS
      $ENDADD
    $ENDIF
    $LCS=0
  $ELSE
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
    $IXA='IXA'
    $NX=NF
    $LCS=1
    $ADD(INIT)
      LCS=1
    $ENDADD
    $ADD(SINIT)
      $SUBST('UYINV1')
      CALL UXVINS(NF,-1,$IXA)
    $ENDADD
    $INITS=0
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
     11 - NORM MINIMIZING UPDATE
     12 - LPD UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10\11\12',3)
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - SIMPLIFIED CONTROLLED SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,4,'1\2\3\4\5',4)
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BASIC USE OF TAYLOR EXPANSION
      3 - MODIFIED USE OF TAYLOR EXPANSION
      4 - HOMOGENEOUS MODEL
      5 - CUBIC MODEL
  $CHECK(MET2,1,'1\2',4)
  $HELP
    METHOD CORRECTION:
      1 - NO CORRECTION - STRONG UPDATE ELIMINATION
      2 - NO CORRECTION - WEAK UPDATE ELIMINATION
      3 - POWELL'S CORRECTION
  $CHECK(MET3,2,'1\2\3',4)
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  NDECF=0
  $SUBST('UASET6')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
   N=NF
  $IF(NAL>0)
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
    $IF(NORMF>0) $SUBST('UATRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $SN=S
    $GN=G
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='S')
    $SUBST('UYFP$(CONSTR)1')
  $ELSEIF(CONSTR='B')
    $ICA=IAA
    $CZ=AZ
    $CR=AR
    $SUBST('UYFP$(CONSTR)2')
  $ENDIF
  $IF(SUBP='Q')
*
*     ------------------------------------------------------
*     RECURSIVE QUADRATIC PROGRAMMING VARIABLE METRIC METHOD
*     TEMPLATE : U1MDU1
*     ------------------------------------------------------
*
  $ELSE
 *
*     -----------------------------------
*     RECURSIVE LINEAR PROGRAMMING METHOD
*     TEMPLATE : U1MDU1
*     -----------------------------------
*
 $ENDIF
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  GMAX=ETA9
$L=$10 ; $LABEL
  $KD=1; $IF(INITH=3) $KD=2
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  N=NF
  UMAX=ZERO
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GO TO $95
$REM  $IF(KBA>0)
$REM    CALL UXVDIF(NA,$AF,$AM,$AF)
$REM  $ENDIF
$L=$ 40 ; $LABEL
  N=NF
  $IF(SUBP='Q')
    $SUBST('UUDSD1')
  $ELSE
    IF (IREST.GT.0) CALL UYSET3
  $ENDIF
  IF (ITERQ.EQ.3) CALL UOERR1(NQPX,102)
  IF (ITERM.NE.0) GO TO $95
  $IF(NUMBER=1)
    CALL UXVCOP(NA,$AF,$AFO)
  $ELSE
    CALL UXVCOP(NA,$AF,$AF(NA+1))
    CALL UXVCOP(2*NA,$AF,$AFO)
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDDX$(SUBP)1
*     -----------------------
*
  $SUBST('UDDX$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  IF (ITERQ.LT.0) THEN
  CALL UYRES1(TDXX)
  GO TO $40
  ENDIF
  $IF(TYPE='L')
    $SUBST('UD1TL2')
  $ELSE
    $SUBST('UD1TG2')
    $IF(SUBP='Q')
      PP=XNORM-F-HALF*P
    $ELSE
      PP=XNORM-F
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $95
  IF (IREST.NE.0) GO TO $40
$L=$ 50 ; $LABEL
  $IF($DEF(MES))
    $IF(MES=5) $SUBST('UAMAXD')
    $IF(INITS=-1) $SUBST('UASTEP')
  $ENDIF
  $SUBST('UYTRUS')
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  $IF(TYPE='C')
    GOTO ($74,$72,$70) ISB+1
$L=$ 70 ; $LABEL
    $AZS='AZS'
    $SUBST('UYSETA')
    $SUBST('UDDX$(SUBP)1')
    P=UXVDOT(NF,$G,$S)
    GO TO $60
  $ELSE
    GOTO ($74,$72) ISB+1
  $ENDIF
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  $IF(NUMBER=1)
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    CALL UXVCOP(2*NA,$AFO,$AF)
  $ENDIF
  IF(ITERS.LT.0.OR.IDIR.EQ.0.OR.MOT3.EQ.0) THEN
  IF(ITERS.LT.0.OR.IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  $IF(CONSTR='B')
    ELSE
    $SUBST('UCLNF2')
  $ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $90 TO IMD
  GO TO $10
  ENDIF
$L=$ 90 ; $LABEL
  TXFU=TUXX
  $IF(SUBP='Q')
    $GN=G
    $IF(MCL=0)
      $SUBST('UYTRAD')
    $ELSE
      $SUBST('UYTRFD')
    $ENDIF
    $DEC='G'
    $SUBST('UUDB$(DEC)1')
  $ELSE
    $SUBST('UYTRED')
  $ENDIF
  IF (MOT2.GT.0) THEN
  IF (ITERH.NE.0) CALL UYRES1('UPDATE  ')
  ENDIF
  GOTO $30
$L=$ 95 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UATRL1')
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1MDU1'
  $ENDADD
  $ADD(SINIT)
    $SUBST('UASET1')
  $ENDADD
  $EXIT
