$INTERFACE U2FBU1                                             97/12/01
$REM LU
  $N='NF'
  $ADD(INTEGER,'\IMD')
  $HERF='B'
  $HELP
    MAXIMUM SIZE OF THE PARTITIONED HESSIAN MATRIX
  $CHECK(MAH,'25*$NA',INT,1)
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $DECOMP='M'
  $NUMBER=3
  $IF(TYPE='L')
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
    $LCS=0
  $ELSE
    $KDS=0
    $LCS=1
  $ENDIF
  $ADD(INIT)
    LCS=$LCS
  $ENDADD
  $IF(MODEL='AQ')
    $HELP
      COMBINATION WITH THE GAUSS-NEWTON METHOD:
        1 - NEWTON'S METHOD
        2 - COMBINED METHOD
    $CHECK(MET,2,'1\2',3)
    $HELP
      TOLERANCE FOR SWITCH TO THE NEWTON METHOD
    $CHECK(ETA5,'1.5$P-4',REAL,4)
  $ELSEIF(MODEL='AP')
    $HELP
      COMBINATION WITH THE GAUSS-NEWTON METHOD:
        1 - NEWTON'S METHOD
        2 - COMBINED METHOD
    $CHECK(MET,2,'1\2',3)
    $HELP
      TOLERANCE FOR SWITCH TO THE NEWTON METHOD
    $CHECK(ETA5,'1.5$P-4',REAL,4)
  $ENDIF
  $UPDATE='NO'
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPS1')
*
*     -------------------------
*     PARTITIONED NEWTON METHOD
*     TEMPLATE : U2FBU1
*     -------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
$L=$10 ; $LABEL
  $KD=2
  $SUBST('UZMODL')
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $IF(NORMF=3) $SUBST('UYNOR2')
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$30 ; $LABEL
  $SUBST('UUBSD1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $SUBST('UYTB$(CONSTR)H')
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDG$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDG$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(MA,$JAG)
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$52 ; $LABEL
  $IF(CONSTR='C')
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$54 ; $LABEL
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $30
  ENDIF
  IF(KD.GT.LD) THEN
  IF(MET.GE.2.AND.FO-F.GE.ETA5*FO) IPOM1=1
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  IPOM1=0
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  $IF(CONSTR='C')
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GOTO $20
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2FBU1'
  $ENDADD
  $EXIT
