$INTERFACE UDSLG3                                             03/12/01
$REM LU
  $D=GO
  $CON1='1.0$P-3'
  $CON2='1.0$P 4'
  $CON3='0.9$P 0'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    TERMINATION
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
  $CHECK(MOS1,1,'0\1',4)
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMMOTHING
  $CHECK(MOS3,1,'0\1',4)
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $DEFAULT='1.0$P-2'
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,DEFAULT,REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF1,'1.8$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $DEFAULT='2.0$P 0'
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,DEFAULT,REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'2.0$P-1',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'1.0D-8',REAL,4)
  $ADD(REAL,'\$H($MMAX)\$CG($MC)\$CF($NC)\$GC($NF)\$G($NF)&
  \$S($NF+$NC)\$XO($NF)\$GO($NF)\$XS($NF)\$GS($NC)\$XP($NC)&
  \$GP($NF)\$CZ($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)&
  \$IX($NX)\$PSL($NF+1)\$PERM($NF)\$WN11($NF+1)\$WN12($NF+1)')
  $ADD(REAL,'\RHO\RHO1\RHO2\ALF\TEMP\TEMP1\TEMP2\BTB\BTR\RMU')
  $ADD(REAL,'\UX$(POM1)DOT\UXVDOT\UXWDOT\UXVSAB')
  $ADD(INTEGER,'\I\K\L\MM\MMX')
  $ADD(LOGICAL,'\L1')
  $IF(MEP=1)
    $ADD(REAL,'\$CP($NC)')
  $ENDIF
  CALL UOD1D1
*
*     SYSTEM TRANSFORMATION
*
  $SUBST('UDSLGA')
  IF(IDECF.NE.0.AND.IDECF.NE.1) THEN
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UDSLG3',1)
  GO TO $90
  ENDIF
  INITD=MAX(ABS(INITD),1)
  MM=$IH($N+1)-1
  IF(IDECF.NE.1) THEN
  CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
  IF (ITERM.NE.0) THEN
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
  RHO=ETA2
  CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XS,INF&
,RHO,ALF)
  NDECF=NDECF+1
  IDECF=1
  ENDIF
*
*     RIGHT HAND SIDE PREPARATION
*
  CALL UXVCOP($N,$GC,$S)
  CALL UXVSFP($N,$PERM,$S,$XS)
  CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
  CALL UXVSBP($N,$PERM,$S,$XS)
  CALL UXSRMD($N,$NN,MC,$CG,$ICG,$JCG,$S,ONE,$CF,$GS)
  RHO1 = UXVSAB($NN,$GS)
*
*     CONSTRUCTION OF PRECONDITIONER
*
  $LGI=$90
  $SUBST('UDSLGI')
  PAR=MIN(EPS6,RHO1)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE($NN)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
*
*     CG INITIATION
*
  CALL UXVSET($NN,ZERO,$S($N+1))
  CALL UXVSET($NN,ZERO,$XP)
  CALL UXVCOP($NN,$GS,$XO)
  CALL UXVCOP($NN,$GS,$XS)
*
*     CG PRECONDITIONING
*
  $FILE=XO
  $SUBST('UDSLGP')
  RHO=UXVDOT($NN,$XO,$XS)
  MMX=2*$NN
*
*    CG ITERATIONS
*
  DO $40 NRED=1,MMX
  CALL UXSCMM($N,$NN,MC,$CG,$ICG,$JCG,$XO,$S)
  CALL UXVSFP($N,$PERM,$S,$GP)
  CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
  CALL UXVSBP($N,$PERM,$S,$GP)
  CALL UXSRMM($N,$NN,MC,$CG,$ICG,$JCG,$S,$GO)
  ALF=UXVDOT($NN,$XO,$GO)
  IF (ALF.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UDSLG3',5)
  GO TO $90
  ENDIF
*
*     CG STEP
*
  TDXX='CG  STEP'
  ALF=RHO/ALF
  CALL UXVDIR($NN,ALF,$XO,$XP,$XP)
  CALL UXVDIR($NN,-ALF,$GO,$XS,$XS)
  $IF(MOS3=0)
    CALL UXVCOP($NN,$XS,$GS)
    CALL UXVCOP($NN,$XP,$S($N+1))
  $ELSE
*
*     CG SMOOTHING
*
    RMU=ONE/ETA9
    CALL UXVDIF($NN,$GS,$XS,$GP)
    BTB=UXVDOT($NN,$GP,$GP)
    BTR=UXVDOT($NN,$GP,$XS)
    RMU=-BTR/MAX(BTB,RMU)
    CALL UXVDIR($NN,RMU,$GP,$XS,$GS)
    CALL UXVDIF($NN,$S($N+1),$XP,$GP)
    CALL UXVDIR($NN,RMU,$GP,$XP,$S($N+1))
  $ENDIF
*
*     TERMINATION CRITERION
*
  L1=NRED.GE.MMX
  $LGT=$50
  $SUBST('UDSLGT')
*
*     CG PRECONDITIONING
*
  $IF(MOS2=0)
    $FILE=XS
  $ELSE
    $FILE=GO
    CALL UXVCOP($NN,$XS,$GO)
  $ENDIF
  $SUBST('UDSLGP')
  RHO2=UXVDOT($NN,$XS,$FILE)
  ALF=RHO2/RHO
  CALL UXVDIR($NN,ALF,$XO,$FILE,$XO)
  RHO=RHO2
$40 CONTINUE
  TDXX = 'MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$50 CONTINUE
  CALL UXSCMM($N,$NN,MC,$CG,$ICG,$JCG,$S($N+1),$GP)
  CALL UXVDIF($N,$GC,$GP,$S)
  CALL UXVSFP($N,$PERM,$S,$XS)
  CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$S,0)
  CALL UXVSBP($N,$PERM,$S,$XS)
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  $SUBST('UDSLGD')
$90 CONTINUE
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UDSLG3'
  $ENDADD
  $EXIT
