$INTERFACE US0L01                                             97/12/01
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,4,'1\2\3\4',3)
  $HELP
    SWITCH FOR EXTRAPOLATION:
      1 - CONSTANT INCREASING OF THE INTERVAL
      2 - EXTRAPOLATION SPECIFIED BY THE PARAMETER MES
      3 - SUPPRESSED EXTRAPOLATION
  $CHECK(MES1,2,'1\2\3',4)
  $HELP
    SWITCH FOR TERMINATION OF LINE SEARCH:
      1 - NORMAL TERMINATION
      2 - SPECIAL TERMINATION FOR NONCONVEX FUNCTIONS
      3 - TERMINATION AFTER AT LEAST TWO STEPS
          (ASYMPTOTICALLY PERFECT LINE SEARCH)
  $CHECK(MES2,2,'1\2\3',4)
  $HELP
    UPPER BOUND FOR FUNCTION VALUE
  $CHECK(FMAX,'1.0$P 20',REAL,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE FUNCTION VALUE)
  $CHECK(EPS1,'1.0$P-4',REAL,4)
  $IF(NONMONOTONE=0)
  $ELSE
    $HELP
      PARAMETER FOR NONMONOTONE SEARCH (ZERO.LE.EPS5.LE.ONE)
    $CHECK(EPS5,'0.5$P 0',REAL,4)
  $ENDIF
  $HELP
    MAXIMUM NUMBER OF EXTRAPOLATIONS OR INTERPOLATIONS
  $CHECK(MRED,10,INT,4)
  CALL US0L01(EPS1,EPS5,RO,RP,R,FO,FP,F,PO,PP,FMIN,FMAX,PAR1,PAR2,RMAX&
,RMIN,SNORM,MODE,KTERS,MES,MES1,MES2,INITS,MRED,$NONMONOTONE)
$REM  $ADD(REAL,'\EPS1\EPS5\RO\RP\R\FO\FP\F\PO\PP\FMIN\FMAX\PAR1&
$REM  \PAR2\RMAX\RMIN\SNORM')
$REM  $ADD(INTEGER,'\MODE\KTERS\MES\MES1\MES2\INITS\MRED')
  $ADD(INIT)
    NSXX='US0L01'
  $ENDADD
  $EXIT
