$REM +---------------------------------------------------------------+
$REM + TEMPLATE: UZSIFD                                    01/12/98  +
$REM + LU                                                            +
$REM + PURPOSE:  SPECIFICATION OF PROBLEM                            +
$REM +---------------------------------------------------------------+

$OPTION(SIFDEC=.TRUE.)

$KH='KH'
$SUBST('P')
$IF($DEF(NA))
$ELSE
  $NA=0
$ENDIF
$IF($DEF(NC))
$ELSE
  $NC=0
$ENDIF
$REM ---- TADY DODELAT VOLBU RIDKOSTI ----
$IF($DEF(JACA))
  $IF(JACA='S') $HESF='S'
$ENDIF
$IF($DEF(JACC))
  $IF(JACC='S') $HESF='S'
$ENDIF
$IF($DEF(HESF))
$ELSE
  $HESF='D'
$ENDIF
$ENDIF
$REM -------------------------------------
$KBF=2
$IF(NA>1)
  $HELP
    TYPE OF OBJECTIVE FUNCTION
      FF - GENERAL FUNCTION
      AF - SUM OF FUNCTIONS
  $CHECK(MODEL,'FF','FF\AF',1,NO)
$ELSE
 $MODEL='FF'
$ENDIF
$IF(MODEL='AF')
  $KCA=2
  $KSA=1
  $NAL=0
  $SET(FMODELA)
    CALL SAFUXX(NF,KA,X,FA)
  $ENDSET
  $SET(GMODELA)
    CALL SAGUXX(NF,KA,X,GA)
  $ENDSET
  $HESF='S'
  $IF (HESF='S')
    $JACA='S'
    $HELP
      NUMBER OF NONZERO ELEMENTS IN THE
      SPARSE JACOBIAN MATRIX
    $CHECK(MA,'10*$NA',INT,1)
  $ENDIF
$ELSE
  $KCF=2
  $KSF=1
  $SET(FMODELF)
    CALL SFFUXX(NF,X,FF)
  $ENDSET
  $SET(GMODELF)
    CALL SFGUXX(NF,X,GF)
  $ENDSET
$ENDIF
$KBC=0
$IF(NC>0)
  $KBC=2
  $KCC=2
  $KSC=1
  $NCL=0
  $SET(FMODELC)
    CALL SCFUXX(NF,KC,X,FC)
  $ENDSET
  $SET(GMODELC)
    CALL SCGUXX(NF,KC,X,GC)
  $ENDSET
  $IF(HESF='S')
    $JACC='S'
    $HELP
      NUMBER OF NONZERO ELEMENTS IN THE
      SPARSE JACOBIAN MATRIX
    $CHECK(MC,'10*$NC',INT,1)
  $ENDIF
  $IF(MODEL='AF')
    $IF(HESF='S')
      $SET(INPUT)
        CALL SINBXX(NF,NA,MA,NC,MC,$X,$IX,$XL,$XU,$IAG,$JAG,$CF,$IC&
,$CL,$CU,$ICG,$JCG,$NF,$NA,$MA,$NC,$MC)
      $ENDSET
    $ENDIF
  $ELSE
    $IF(HESF='S')
      $HELP
        NUMBER OF NONZERO ELEMENTS IN THE
        SPARSE HESSIAN MATRIX
      $CHECK(M,'20*$NF',INT,1)
      $SET(INPUT)
        $ADD(INTEGER,'\$KH($M)')
        CALL SINSXX(NF,NC,MC,M,$X,$IX,$XL,$XU,$IH,$JH,$KH,$CF,$IC&
,$CL,$CU,$ICG,$JCG,$NF,$NC,$MC,$M,ITERM)
      $ENDSET
    $ELSE
      $SET(INPUT)
        CALL SINDXX(NF,NC,$X,$IX,$XL,$XU,$CF,$IC,$CL,$CU,$NF,$NC)
      $ENDSET
    $ENDIF
  $ENDIF
$ELSE
  $IF(MODEL='AF')
    $IF(HESF='S')
      $SET(INPUT)
        CALL SIUBXX(NF,NA,MA,$X,$IX,$XL,$XU,$IAG,$JAG,$NF,$NA,$MA)
      $ENDSET
    $ENDIF
  $ELSE
    $IF(HESF='S')
      $HELP
        NUMBER OF NONZERO ELEMENTS IN THE
        SPARSE HESSIAN MATRIX
      $CHECK(M,'20*$NF',INT,1)
      $SET(INPUT)
        $ADD(INTEGER,'\$KH($M)')
        CALL SIUSXX(NF,M,$X,$IX,$XL,$XU,$IH,$JH,$KH,$NF,$M,ITERM)
      $ENDSET
    $ELSE
      $SET(INPUT)
        CALL SIUDXX(NF,$X,$IX,$XL,$XU,$NF)
      $ENDSET
    $ENDIF
  $ENDIF
$ENDIF
